#include<bits/stdc++.h>
#define all(p) p.begin(),p.end()
using namespace std;
#define int long long
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    int a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            swap(a[x], a[x + 1]);
        } else {
            int x;
            cin >> x;
            // int cnt = 0;
            deque<int>st;
            deque<int>cur;
            vector<int>ans;
            for (int i = 1; i <= n; i++) {
                st.push_back(i);
                if (i == n || a[i + 1] != a[i]) {
                    while (!cur.empty() && !st.empty() && a[cur.front()] != a[st.front()]) {
                        int d = cur.front();
                        int b = st.front();
                        if (!ans.empty() && a[ans.back()] == a[d]) {
                            swap(d, b);
                        }
                        ans.push_back(d);
                        ans.push_back(b);
                        cur.pop_front();
                        st.pop_front();
                    }
                    for (auto y : st) {
                        cur.push_back(y);
                    }
                    st.clear();
                }
                // cout << "! ";
                // for (auto u : cur1) {
                //     cout << u << ' ';
                // }
                // cout << "    ";
                // for (auto u : cur2) {
                //     cout << u << ' ';
                // }
                // cout << endl;
            }
            for (auto u : cur) {
                ans.push_back(u);
            }
            for (int i = 0; i < ans.size(); i++) {
                if (ans[i] == x) {
                    cout << i + 1 << endl;
                    break;
                }
            }
            // for (auto u : ans) {
            //     cout << u << ' ';
            // }
            // cout << endl;
        }
    }
}